/*****************************************
 * Steven Stanek
 * July 7, 2001
 * YZBufferedDraw.h
 * Version 0.0.0a
 *****************************************/
 
#ifndef yzbuffereddraw_H
#define yzbuffereddraw_H
 
#include <stdlib.h>
#include <math.h>
#include <yz/image.h>

typedef struct yzBufferCDT *yzGraphicsBuffer;


//Width and Height are in pixels, depth is in bytes
yzGraphicsBuffer createNewBuffer(int width, int height, int depth);

//Adds image at x & y to graphics buffer. Width, Height & rowbytes refer to the void *
//Note: if you only want part of a row to show, set rowbytes (width must be actual
//width though). This is useful when a large area is stored in memory and the user
//scrolls around it in such a way that only a small portion of the buffer appears on
//screen.
void addToGraphicsBuffer(yzGraphicsBuffer aBuf, int x, int y, void *data, int width, int height, int rowbytes);


//Similar to addToGraphicsBuffer. The transValue must point to a variable of the same size as the bit depth
void addToGraphicsBufferWithTransparency(yzGraphicsBuffer aBuf, int x, int y, void *data, int width, 
	int height, int rowbytes, void *transValue);
	
//Draws to current Window at given coords
void drawGraphicsBuffer(yzGraphicsBuffer aBuf, int x, int y);

//Frees All Memory Associated with a yzGraphicsBuffer
void freeGraphicsBuffer(yzGraphicsBuffer toFree);

#endif